<?php require_once( 'Fsqlfilelock.php' ); require_once( 'Fsqltablecursor.php' ); class Fsqlcachedtable { var $cursor = NULL; var $columns = NULL; var $entries = NULL; var $columns_path = NULL; var $data_path = NULL; var $columns_load = NULL; var $data_load = NULL; var $uncommited = false; var $columnsLockFile = NULL; var $columnsFile = NULL; var $dataLockFile = NULL; var $dataFile = NULL; var $lock = NULL; function Fsqlcachedtable($path_to_db, $table_name) { $this->columns_path = $path_to_db.$table_name.'.columns'; $this->data_path = $path_to_db.$table_name.'.data'; $this->columnsLockFile = new Fsqlfilelock($this->columns_path.'.lock.cgi'); $this->columnsFile = new Fsqlfilelock($this->columns_path.'.cgi'); $this->dataLockFile = new Fsqlfilelock($this->data_path.'.lock.cgi'); $this->dataFile = new Fsqlfilelock($this->data_path.'.cgi'); } function create($path_to_db, $table_name, $columnDefs) { $table = new Fsqlcachedtable($path_to_db, $table_name); $table->columns = $columnDefs; list($msec, $sec) = explode(' ', microtime()); $table->columns_load = $table->data_load = $sec.$msec; $table->columnsLockFile->acquireWrite(); $columnsLock = $table->columnsLockFile->getHandle(); ftruncate($columnsLock, 0); fwrite($columnsLock, $table->columns_load); $table->columnsFile->acquireWrite(); $toprint = $table->_printColumns($columnDefs); fwrite($table->columnsFile->getHandle(), $toprint); $table->columnsFile->releaseWrite(); $table->columnsLockFile->releaseWrite(); $table->dataLockFile->acquireWrite(); $dataLock = $table->dataLockFile->getHandle(); ftruncate($dataLock, 0); fwrite($dataLock, $table->data_load); $table->dataFile->acquireWrite(); fwrite($table->dataFile->getHandle(), "0\r\n"); $table->dataFile->releaseWrite(); $table->dataLockFile->releaseWrite(); return $table; } function _printColumns($columnDefs) { $toprint = count($columnDefs)."\r\n"; foreach($columnDefs as $name => $column) { if(!is_array($column['restraint'])) { $toprint .= $name.": ".$column['type'].";;".$column['auto'].";".$column['default'].";".$column['key'].";".$column['null'].";\r\n"; } else { $toprint .= $name.": ".$column['type'].";".implode(",", $column['restraint']).";".$column['auto'].";".$column['default'].";".$column['key'].";".$column['null'].";\r\n"; } } return $toprint; } function exists() { return file_exists($this->columns_path.'.cgi'); } function getColumnNames() { return array_keys($this->getColumns()); } function getColumns() { $this->columnsLockFile->acquireRead(); $lock = $this->columnsLockFile->getHandle(); $modified = fread($lock, 20); if($this->columns_load === NULL || strcmp($this->columns_load, $modified) < 0) { $this->columns_load = $modified; $this->columnsFile->acquireRead(); $columnsHandle = $this->columnsFile->getHandle(); $line = fgets($columnsHandle); if(!preg_match("/^(\d+)/", $line, $matches)) { $this->columnsFile->releaseRead(); $this->columnsLockFile->releaseRead(); return NULL; } $num_columns = $matches[1]; for($i = 0; $i < $num_columns; $i++) { $line = fgets($columnsHandle, 4096); if(preg_match("/(\S+): (dt|d|i|f|s|t|e);(.*);(0|1);(-?\d+(?:\.\d+)?|'.*'|NULL);(p|u|k|n);(0|1);/", $line, $matches)) { $type = $matches[2]; $default = $matches[5]; if($type === 'i') $default = (int) $default; else if($type === 'f') $default = (float) $default; $this->columns[$matches[1]] = array( 'type' => $type, 'auto' => $matches[4], 'default' => $default, 'key' => $matches[6], 'null' => $matches[7] ); preg_match_all("/'.*?(?<!\\\\)'/", $matches[3], $this->columns[$matches[1]]['restraint']); $this->columns[$matches[1]]['restraint'] = $this->columns[$matches[1]]['restraint'][0]; } else { return NULL; } } $this->columnsFile->releaseRead(); } $this->columnsLockFile->releaseRead(); return $this->columns; } function getCursor() { $this->_loadEntries(); if($this->cursor == NULL) $this->cursor = new Fsqltablecursor; $this->cursor->entries = $this->entries; $this->cursor->num_rows = count($this->entries); $this->cursor->pos = 0; return $this->cursor; } function _loadEntries() { $this->dataLockFile->acquireRead(); $lock = $this->dataLockFile->getHandle(); $modified = fread($lock, 20); if($this->data_load === NULL || strcmp($this->data_load, $modified) < 0) { $entries = NULL; $this->data_load = $modified; $this->dataFile->acquireRead(); $dataHandle = $this->dataFile->getHandle(); $line = fgets($dataHandle); if(!preg_match("/^(\d+)/", $line, $matches)) { $this->dataFile->releaseRead(); $this->dataLockFile->releaseRead(); return NULL; } $num_entries = rtrim($matches[1]); if($num_entries != 0) { $columns = array_keys($this->getColumns()); $skip = false; $entries = array(); for($i = 0; $i < $num_entries; $i++) { $line = rtrim(fgets($dataHandle, 4096)); if(!$skip) { if(preg_match("/^(\d+):(.*)$/", $line, $matches)) { $row = $matches[1]; $data = trim($matches[2]); } else continue; } else { $data .= $line; } if(!preg_match("/(-?\d+(?:\.\d+)?|'.*?(?<!\\\\)'|NULL);$/", $line)) { $skip = true; continue; } else { $skip = false; } preg_match_all("#(-?\d+(?:\.\d+)?|'.*?(?<!\\\\)'|NULL);#s", $data, $matches); for($m = 0; $m < count($matches[0]); $m++) { if($matches[1][$m] == 'NULL') $entries[$row][$columns[$m]] = NULL; else $entries[$row][$columns[$m]] = $matches[1][$m]; } } } $this->entries = $entries; $this->dataFile->releaseRead(); } $this->dataLockFile->releaseRead(); return true; } function insertRow($data) { $this->_loadEntries(); $this->entries[] = $data; $this->uncommited = true; } function updateRow($row, $data) { $this->_loadEntries(); foreach($data as $key=> $value) $this->entries[$row][$key] = $value; $this->uncommited = true; } function deleteRow($row) { $this->_loadEntries(); unset($this->entries[$row]); $this->uncommited = true; } function setColumns($columnDefs) { $this->columnsLockFile->acquireWrite(); $lock = $this->columnsLockFile->getHandle(); $modified = fread($lock, 20); $this->columns = $columnDefs; list($msec, $sec) = explode(' ', microtime()); $this->columns_load = $sec.$msec; fseek($lock, 0, SEEK_SET); fwrite($lock, $this->columns_load); $this->columnsFile->acquireWrite(); $toprint = $this->_printColumns($columnDefs); $columnsHandle = $this->columnsFile->getHandle(); ftruncate($columnsHandle, 0); fwrite($columnsHandle, $toprint); $this->columnsFile->releaseWrite(); $this->columnsLockFile->releaseWrite(); } function commit() { if($this->uncommited === false) return; $this->dataLockFile->acquireWrite(); $lock = $this->dataLockFile->getHandle(); $modified = fread($lock, 20); if($this->data_load === NULL || strcmp($this->data_load, $modified) >= 0) { $toprint = count($this->entries)."\r\n"; foreach($this->entries as $number => $entry) { $toprint .= $number.': '; foreach($entry as $key => $value) { if($value === NULL) $value = 'NULL'; $toprint .= $value.';'; } $toprint .= "\r\n"; } } else { $toprint = "0\r\n"; } list($msec, $sec) = explode(' ', microtime()); $this->data_load = $sec.$msec; fseek($lock, 0, SEEK_SET); fwrite($lock, $this->data_load); $this->dataFile->acquireWrite(); $dataHandle = $this->dataFile->getHandle(); ftruncate($dataHandle, 0); fwrite($dataHandle, $toprint); $this->dataFile->releaseWrite(); $this->dataLockFile->releaseWrite(); $this->uncommited = false; } function rollback() { $this->data_load = 0; $this->uncommited = false; } function isReadLocked() { return $this->lock === 'r'; } function readLock() { $success = $this->columnsLockFile->acquireRead() && $this->columnsFile->acquireRead() && $this->dataLockFile->acquireRead() && $this->dataFile->acquireRead(); if($success) { $this->lock = 'r'; return true; } else { $this->unlock(); return false; } } function writeLock() { $success = $this->columnsLockFile->acquireRead() && $this->columnsFile->acquireRead() && $this->dataLockFile->acquireRead() && $this->dataFile->acquireRead(); if($success) { $this->lock = 'w'; return true; } else { $this->unlock(); return false; } } function unlock() { if($this->lock === 'r') { $this->columnsLockFile->releaseRead(); $this->columnsFile->releaseRead(); $this->dataLockFile->releaseRead(); $this->dataFile->releaseRead(); } else if($this->lock === 'w') { $this->columnsLockFile->releaseWrite(); $this->columnsFile->releaseWrite(); $this->dataLockFile->releaseWrite(); $this->dataFile->releaseWrite(); } $this->lock = null; return true; } }